<?php

// src/Controller/DataImport.php
// Grab data from transfer app

namespace App\Controller\Routes\Back;

use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\RequestStack;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
//use App\Utils\PageRender;
use App\Service\Auth;

class Index extends AbstractController
{
    /**
     * @Route("/den", name="back-index")
     */
    public function enterTheDen(Request $request, Auth $auth, RequestStack $requestStack): Response
    {
        if ($request->getMethod() == "GET") {
            $result = $auth->status();
            if ($result["status"]) {
                $session = $requestStack->getSession();
                $member  = $session->get("member");
                return $this->render("back/start.twig", [
                    "title"  => "Welcome Back",
                    "handle" => $member->getHandle()
                ]);
            } else {
                return $this->render("back/index.twig", [
                    "title" => "Close the door behind you",
                ]);
            }
        } else {
            //handles login
            $handle = $request->request->get("handle");
            $pass   = $request->request->get("password");
            $result = $auth->authCheck($handle, $pass);
            if ($result["status"]) {
                header("Location:/den");
                return new Response("<html><body>LOGGED IN</body></html>");
            } else {
                return $this->render("back/index.twig", [
                    "title"  => "Close the door behind you",
                    "notice" => $result["message"]
                ]);
            }
        }
    }

    /**
       * @Route("/logout", name="logout-page")
       */
    public function leaveTheDen(Auth $auth)
    {
        $auth->logout();
        header("Location:/den");
        return new Response("<html><body>LOGGED OUT</body></html>");
    }
}
